import { Observable } from "rxjs"
import { FisAppActor } from "./transport.interface"


export type TYPE = {
    adapterProfile: AdapterProfile,
    transmitterProfile: TransmitterProfile,
    receiverProfile: ReceiverProfile
}

export interface AdapterProfile {

}

export interface TransmitterProfile {
    id: string,
    name: string,
    dateCreated: Date
}

export interface ReceiverProfile {
    id: string,
    name: string,
    dateCreated: Date
}

export interface ConnectionManager {

}

export interface ConnectionAdaptorBase extends FisAppActor {
    connector: any
    connectorProfile: AdapterProfile | any
    connectionState: ConnectionState
    connectionStateBus: Observable<ConnectionState>
    adaptorTransmissionRole: AdaptorTransmissionRole

    subscribeConnectionState(): Observable<ConnectionState>
    publishConnectionState(): void
    connect(): void
    disconnect(): void
    send(message: any): Observable<any>
    emit(message: any): void
    emitStream(message: any): void
    subscribeMessages(messageFilter: any): Observable<any>
}


export interface TransmitterAdapterBase extends ConnectionAdaptorBase {

}

export type ConnectionState = 'ONLINE' | 'OFFLINE'
export enum AdaptorTransmissionRole {
    Transmitter,
    Receiever,
    RequestResponse
}